'固定境界の一括設定ﾌﾟﾛｸﾞﾗﾑ

Public Class FEM3Dat3

    Dim KindCylinder As Integer '円筒面の式（0:なし、1:XY式、2:YZ式、3:ZX式）

    Dim Ac As Single            '中心座標A値
    Dim Bc As Single            '中心座標B値

    Dim KAxis(3) As Integer     '座標軸指定の有無
    Dim KfixDisp(3) As Integer  '固定変位指定有無（各変位方向で0:なし、1:有り）

    Dim Rrange(2) As Single     '半径R範囲
    Dim Xrange(2) As Single     'X座標範囲
    Dim Yrange(2) As Single     'Y座標範囲
    Dim Zrange(2) As Single     'Z座標範囲

    Private Sub BoundPTreat()
        '境界節点の処理
        Dim i, ic, j, k, nb As Integer
        Dim xb, yb, zb As Single

        nb = 0
        For i = 1 To Npoint
            ic = 0
            xb = Xdata(i)
            yb = Ydata(i)
            zb = Zdata(i)
            Call CondCheck2(ic, xb, yb, zb)    '条件ﾁｪｯｸ2
            If ic = 0 Then
                nb = nb + 1
            End If
        Next i

        nb = NboundP + nb
        Dim nobuf(nb), jfbuf(nb, Ndim) As Integer
        Dim vfbuf(nb, Ndim) As Single
        If NboundP > 0 Then
            For i = 1 To NboundP
                nobuf(i) = NrestP(i)
                For j = 1 To Ndim
                    jfbuf(i, j) = JdirectP(i, j)
                    vfbuf(i, j) = VdirectP(i, j)
                Next j
            Next i
        End If

        nb = NboundP
        For i = 1 To Npoint
            ic = 0
            xb = Xdata(i)
            yb = Ydata(i)
            zb = Zdata(i)
            Call CondCheck2(ic, xb, yb, zb)    '条件ﾁｪｯｸ2
            If ic = 0 Then
                nb = nb + 1
                nobuf(nb) = i
                For j = 1 To Ndim
                    If KfixDisp(j) > 0 Then
                        jfbuf(nb, j) = 1
                        vfbuf(nb, j) = 0
                    End If
                Next j
            End If
        Next i
        NboundP = nb
        ReDim NrestP(NboundP)
        ReDim JdirectP(NboundP, Ndim), VdirectP(NboundP, Ndim)
        For i = 1 To NboundP
            NrestP(i) = nobuf(i)
            For j = 1 To Ndim
                JdirectP(i, j) = jfbuf(i, j)
                VdirectP(i, k) = vfbuf(i, j)
            Next j
        Next i

    End Sub

    Private Sub BoundTreat()
        '境界面の処理
        Dim i, ic, ie, jmax, k, kb, kmax, nb As Integer
        Dim xb, yb, zb As Single

        If KindElem = 0 Then
            jmax = 6
            kmax = 8
        End If
        Call ElemPrep()     '要素準備
        Call InnerCheck2(1, Nelem)    '内面ﾁｪｯｸ
        nb = 0
        For ie = 1 To Nelem
            For kb = 1 To jmax
                If KSelem(ie, kb) = 0 Then
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, kb, KsurfPoint)     '面の設定
                    End If
                    ic = 0
                    For k = 1 To kmax
                        xb = Xdata(KsurfPoint(k))
                        yb = Ydata(KsurfPoint(k))
                        zb = Zdata(KsurfPoint(k))
                        Call CondCheck2(ic, xb, yb, zb)    '条件ﾁｪｯｸ2
                        If ic > 0 Then
                            Exit For
                        End If
                    Next k
                    If ic = 0 Then
                        nb = nb + 1
                    End If
                End If
            Next kb
        Next ie

        nb = NboundS + nb
        Dim kbsbuf(nb, 2), jdsbuf(nb, Ndim) As Integer
        Dim vdsbuf(nb, Ndim) As Single
        If NboundS > 0 Then
            For i = 1 To NboundS
                kbsbuf(i, 1) = KBsurf(i, 1)
                kbsbuf(i, 2) = KBsurf(i, 2)
                For k = 1 To 3
                    jdsbuf(i, k) = JdirectS(i, k)
                    vdsbuf(i, k) = VdirectS(i, k)
                Next k
            Next i
        End If

        nb = NboundS
        For ie = 1 To Nelem
            For kb = 1 To jmax
                If KSelem(ie, kb) = 0 Then
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, kb, KsurfPoint)     '面の設定
                    End If
                    ic = 0
                    For k = 1 To kmax
                        xb = Xdata(KsurfPoint(k))
                        yb = Ydata(KsurfPoint(k))
                        zb = Zdata(KsurfPoint(k))
                        Call CondCheck2(ic, xb, yb, zb)    '条件ﾁｪｯｸ2
                        If ic > 0 Then
                            Exit For
                        End If
                    Next k
                    If ic = 0 Then
                        nb = nb + 1
                        kbsbuf(nb, 1) = ie
                        kbsbuf(nb, 2) = kb
                        For k = 1 To 3
                            If KfixDisp(k) > 0 Then
                                jdsbuf(nb, k) = 1
                                vdsbuf(nb, k) = 0
                            End If
                        Next k
                    End If
                End If
            Next kb
        Next ie
        NboundS = nb
        ReDim KBsurf(NboundS, 2)
        ReDim JdirectS(NboundS, Ndim), VdirectS(NboundS, Ndim)
        For i = 1 To NboundS
            KBsurf(i, 1) = kbsbuf(i, 1)
            KBsurf(i, 2) = kbsbuf(i, 2)
            For k = 1 To 3
                JdirectS(i, k) = jdsbuf(i, k)
                VdirectS(i, k) = vdsbuf(i, k)
            Next k
        Next i

    End Sub

    Private Sub CondCheck(ByRef ic As Integer)
        '条件ﾁｪｯｸ
        'ic･･･ｴﾗｰ種別（-2:範囲指定なし、-1：範囲ｴﾗｰ）
        If KAxis(1) > 0 Then
            ic = 1
            If Xrange(1) > Xrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If KAxis(2) > 0 Then
            ic = 1
            If Yrange(1) > Yrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If KAxis(3) > 0 Then
            ic = 1
            If Zrange(1) > Zrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If KindCylinder > 0 Then
            ic = 1
            If Rrange(1) > Rrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If ic = 0 Then
            ic = -2
        End If

    End Sub

    Private Sub CondCheck2(ByRef ic As Integer, ByVal xb As Single, _
        ByVal yb As Single, ByVal zb As Single)
        '条件ﾁｪｯｸ2
        'ic･･･条件外れ有無（0:条件内、1:条件外れ）
        'xb,yb,zb･･･点の座標
        Dim b1, b2, b3 As Single
        If KAxis(1) > 0 Then
            If xb < Xrange(1) Or xb > Xrange(2) Then
                ic = 1
                Exit Sub
            End If
        End If
        If KAxis(2) > 0 Then
            If yb < Yrange(1) Or yb > Yrange(2) Then
                ic = 1
                Exit Sub
            End If
        End If
        If KAxis(3) > 0 Then
            If zb < Zrange(1) Or zb > Zrange(2) Then
                ic = 1
                Exit Sub
            End If
        End If
        If KindCylinder > 0 Then
            Select Case KindCylinder
                Case 1
                    b1 = xb - Ac
                    b2 = yb - Bc
                Case 2
                    b1 = yb - Ac
                    b2 = zb - Bc
                Case 3
                    b1 = zb - Ac
                    b2 = xb - Bc
            End Select
            b3 = Math.Sqrt(b1 * b1 + b2 * b2)
            If b3 < Rrange(1) Or b3 > Rrange(2) Then
                ic = 1
            End If
        End If

    End Sub

    Private Sub ElemPrep()
        '要素準備
        Dim ie As Integer
        ReDim KdrawElem(Nelem), KSelem(Nelem, 6)

        For ie = 1 To Nelem
            KdrawElem(ie) = 1
        Next ie

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ic, ix As Integer

        If RadioButton1.Checked = True Then
            KboundSet(1) = 1
        Else
            KboundSet(1) = 2
        End If

        If CheckBox1.Checked = True Then
            KfixDisp(1) = 1
        Else
            KfixDisp(1) = 0
        End If
        If CheckBox2.Checked = True Then
            KfixDisp(2) = 1
        Else
            KfixDisp(2) = 0
        End If
        If CheckBox3.Checked = True Then
            KfixDisp(3) = 1
        Else
            KfixDisp(3) = 0
        End If
        ic = 0
        For i = 1 To 3
            If KfixDisp(i) > 0 Then
                ic = 1
                Exit For
            End If
        Next i
        If ic = 0 Then
            aa$ = "固定する変位がチェックされていません！"
            MsgBox(aa$, 0, "設定エラー")
            Exit Sub
        End If

        If CheckBox4.Checked = True Then
            KAxis(1) = 1
            Xrange(1) = Val(TextBox1.Text)
            Xrange(2) = Val(TextBox2.Text)
        Else
            KAxis(1) = 0
        End If
        If CheckBox5.Checked = True Then
            KAxis(2) = 1
            Yrange(1) = Val(TextBox3.Text)
            Yrange(2) = Val(TextBox4.Text)
        Else
            KAxis(2) = 0
        End If
        If CheckBox6.Checked = True Then
            KAxis(3) = 1
            Zrange(1) = Val(TextBox5.Text)
            Zrange(2) = Val(TextBox6.Text)
        Else
            KAxis(3) = 0
        End If
        If CheckBox7.Checked = True Then
            If RadioButton3.Checked = True Then
                KindCylinder = 1
            ElseIf RadioButton4.Checked = True Then
                KindCylinder = 2
            Else
                KindCylinder = 3
            End If
            Ac = Val(TextBox7.Text)
            Bc = Val(TextBox8.Text)
            Rrange(1) = Val(TextBox9.Text)
            Rrange(2) = Val(TextBox10.Text)
        Else
            KindCylinder = 0
        End If
        ic = 0
        Call CondCheck(ic)  '条件ﾁｪｯｸ
        If ic = -2 Then
            aa$ = "範囲指定がありません！"
            MsgBox(aa$, 0, "条件エラー")
            Exit Sub
        ElseIf ic = -1 Then
            aa$ = "条件範囲が間違っています！"
            MsgBox(aa$, 0, "条件エラー")
            Exit Sub
        End If

        If KboundSet(1) = 1 Then
            KboundSet(2) = NboundP
            Call BoundPTreat()    '境界節点の処理
        Else
            KboundSet(2) = NboundS
            Call BoundTreat()     '境界面の処理
        End If
        KboundSet(0) = KboundSet(1)
        KdataChange = 1

        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New AnalDat6() '解析用ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub

    Private Sub Button3_Click(sender As Object, e As System.EventArgs) Handles Button3.Click
        Dim aa$

        If KboundSet(0) = 0 Then
            aa$ = "境界の一括設定は実施されていません！"
            MsgBox(aa$, 0, "処理中止")
        Else
            If KboundSet(0) = 1 Then
                NboundP = KboundSet(2)
                aa$ = "境界節点の一括設定を元へ戻しました！"
            Else
                NboundS = KboundSet(2)
                aa$ = "境界面の一括設定を元へ戻しました！"
            End If
            KboundSet(0) = 0
            MsgBox(aa$, 0, "処理終了")
        End If
        Me.Close()

    End Sub

    Private Sub FEM3Dat3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If KboundSet(1) = 0 Then
            KboundSet(1) = 1
        End If
        If KboundSet(1) = 1 Then
            RadioButton1.Checked = True
        Else
            RadioButton2.Checked = True
        End If

        RadioButton3.Checked = True

    End Sub
End Class