﻿'表面分布荷重の一括設定ﾌﾟﾛｸﾞﾗﾑ

Public Class FEM3Dat4
    Dim KindCylinder As Integer '円筒面の式（0:なし、1:XY式、2:YZ式、3:ZX式）

    Dim Ac As Single            '中心座標A値
    Dim Bc As Single            '中心座標B値
    Dim Press As Single         '表面分布荷重（圧力）

    Dim KAxis(3) As Integer     '座標軸指定の有無

    Dim Rrange(2) As Single     '半径R範囲
    Dim Xrange(2) As Single     'X座標範囲
    Dim Yrange(2) As Single     'Y座標範囲
    Dim Zrange(2) As Single     'Z座標範囲

    Private Sub CondCheck(ByRef ic As Integer)
        '条件ﾁｪｯｸ
        'ic･･･ｴﾗｰ種別（-2:範囲指定なし、-1：範囲ｴﾗｰ）
        If KAxis(1) > 0 Then
            ic = 1
            If Xrange(1) > Xrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If KAxis(2) > 0 Then
            ic = 1
            If Yrange(1) > Yrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If KAxis(3) > 0 Then
            ic = 1
            If Zrange(1) > Zrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If KindCylinder > 0 Then
            ic = 1
            If Rrange(1) > Rrange(2) Then
                ic = -1
                Exit Sub
            End If
        End If
        If ic = 0 Then
            ic = -2
        End If

    End Sub

    Private Sub CondCheck2(ByRef ic As Integer, ByVal xb As Single, _
        ByVal yb As Single, ByVal zb As Single)
        '条件ﾁｪｯｸ2
        'ic･･･条件外れ有無（0:条件内、1:条件外れ）
        'xb,yb,zb･･･点の座標
        Dim b1, b2, b3 As Single
        If KAxis(1) > 0 Then
            If xb < Xrange(1) Or xb > Xrange(2) Then
                ic = 1
                Exit Sub
            End If
        End If
        If KAxis(2) > 0 Then
            If yb < Yrange(1) Or yb > Yrange(2) Then
                ic = 1
                Exit Sub
            End If
        End If
        If KAxis(3) > 0 Then
            If zb < Zrange(1) Or zb > Zrange(2) Then
                ic = 1
                Exit Sub
            End If
        End If
        If KindCylinder > 0 Then
            Select Case KindCylinder
                Case 1
                    b1 = xb - Ac
                    b2 = yb - Bc
                Case 2
                    b1 = yb - Ac
                    b2 = zb - Bc
                Case 3
                    b1 = zb - Ac
                    b2 = xb - Bc
            End Select
            b3 = Math.Sqrt(b1 * b1 + b2 * b2)
            If b3 < Rrange(1) Or b3 > Rrange(2) Then
                ic = 1
            End If
        End If

    End Sub

    Private Sub ElemPrep()
        '要素準備
        Dim ie As Integer
        ReDim KdrawElem(Nelem), KSelem(Nelem, 6)

        For ie = 1 To Nelem
            KdrawElem(ie) = 1
        Next ie

    End Sub

    Private Sub LoadHAdd(ByVal i As Integer, ByVal j As Integer)
        '表面分布荷重の追加
        'i･･･要素番号
        'j･･･面番号
        Dim ii, jj, nb As Integer
        Dim kphbuf(Nsurf, 2) As Integer
        Dim pnbuf(Nsurf) As Single
        For ii = 1 To Nsurf
            For jj = 1 To 2
                kphbuf(ii, jj) = KPsurf(ii, jj)
            Next jj
            pnbuf(ii) = Pnorm(ii)
        Next ii
        nb = Nsurf + 1
        ReDim KPsurf(nb, 2), Pnorm(nb)
        For ii = 1 To Nsurf
            For jj = 1 To 2
                KPsurf(ii, jj) = kphbuf(ii, jj)
            Next jj
            Pnorm(ii) = pnbuf(ii)
        Next ii
        KPsurf(nb, 1) = i
        KPsurf(nb, 2) = j
        Pnorm(nb) = Press
        Nsurf = nb

    End Sub

    Private Sub LoadHSet()
        '表面分布荷重設定
        Dim i, ic, j, jmax, k, kmax As Integer
        Dim xb, yb, zb As Single

        If KindElem = 0 Then
            jmax = 6
            kmax = 8
        End If
        Call ElemPrep()     '要素準備
        Call InnerCheck2(1, Nelem)    '内面ﾁｪｯｸ
        For i = 1 To Nelem
            For j = 1 To jmax
                ic = 0
                If KSelem(i, j) = 0 Then
                    If KindElem = 0 Then
                        Call SurfaceSet(i, j, KsurfPoint)   '面の設定
                    End If
                    For k = 1 To kmax
                        xb = Xdata(KsurfPoint(k))
                        yb = Ydata(KsurfPoint(k))
                        zb = Zdata(KsurfPoint(k))
                        Call CondCheck2(ic, xb, yb, zb)    '条件ﾁｪｯｸ2
                    Next k
                    If ic = 0 Then
                        Call LoadHAdd(i, j)  '表面分布荷重の追加
                    End If
                End If
            Next j
        Next i

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim ic, ix As Integer

        If CheckBox1.Checked = True Then
            KAxis(1) = 1
            Xrange(1) = Val(TextBox1.Text)
            Xrange(2) = Val(TextBox2.Text)
        Else
            KAxis(1) = 0
        End If
        If CheckBox2.Checked = True Then
            KAxis(2) = 1
            Yrange(1) = Val(TextBox3.Text)
            Yrange(2) = Val(TextBox4.Text)
        Else
            KAxis(2) = 0
        End If
        If CheckBox3.Checked = True Then
            KAxis(3) = 1
            Zrange(1) = Val(TextBox5.Text)
            Zrange(2) = Val(TextBox6.Text)
        Else
            KAxis(3) = 0
        End If
        If CheckBox4.Checked = True Then
            If RadioButton1.Checked = True Then
                KindCylinder = 1
            ElseIf RadioButton2.Checked = True Then
                KindCylinder = 2
            Else
                KindCylinder = 3
            End If
            Ac = Val(TextBox7.Text)
            Bc = Val(TextBox8.Text)
            Rrange(1) = Val(TextBox9.Text)
            Rrange(2) = Val(TextBox10.Text)
        Else
            KindCylinder = 0
        End If
        Press = Val(TextBox11.Text)
        ic = 0
        Call CondCheck(ic)  '条件ﾁｪｯｸ
        If ic = -2 Then
            aa$ = "範囲指定がありません！"
            MsgBox(aa$, 0, "条件エラー")
            Exit Sub
        ElseIf ic = -1 Then
            aa$ = "条件範囲が間違っています！"
            MsgBox(aa$, 0, "条件エラー")
            Exit Sub
        End If

        Call LoadHSet()     '表面分布荷重設定
        KdataChange = 1

        aa$ = "新しい構造データをファイルへ出力しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New AnalDat6() '解析用ﾃﾞｰﾀﾌｧｲﾙ出力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub

    Private Sub FEM3Dat4_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        RadioButton1.Checked = True

    End Sub
End Class