Public Class FEM3Dat6
    '円形分布荷重の座標位置荷重への変換設定ﾌﾟﾛｸﾞﾗﾑ

    Dim Fx$         'ﾌｧｲﾙ名

    Dim MeshStd As Integer      '1辺のメッシュ数
    Dim Nfp As Integer          '荷重点数

    Dim Rlen As Single          '円の半径

    Dim Kat() As Integer        '各節点の線分番号(ただし、-1:内点、-2:外点)
    Dim NNmesh(,) As Integer    '各メッシュ点の節点番号
    Dim Npmesh() As Integer     '各メッシュ線毎の節点数

    Dim Aratio() As Single      '各区分の面積比率
    Dim Cx(3), Cy(3) As Single  'XY座標の全体座標に対する方向余弦
    Dim Fpoint(,) As Single     '座標位置の荷重
    Dim Fsum(3) As Single         '合計荷重

    Dim Xbuf(), Ybuf() As Single        'メッシュ点座標
    Dim XPL(), YPL() As Single          '荷重点の平面座標
    Dim Xfp(), Yfp(), Zfp() As Single   '荷重点の全体座標
    Dim Xset(3), Yset(3), Zset(3) As Single   '3点の座標

    Private Sub AreaCalcPL(ByRef area As Single, ByVal xebuf() As Single, ByVal yebuf() As Single)
        'XY平面の要素面積の計算
        'area･･･面積
        'xebuf(),yebuf()･･･8節点のX,Y座標
        Dim ig, jg, kg As Integer
        Dim da, dj, s, t As Single
        Dim dsb(8), dtb(8), shb(8) As Single

        area = 0
        kg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                kg = kg + 1
                Call ShapeFunc2DL(s, t, shb, dsb, dtb)            '形状関数の計算
                Call JacobElem2DL(kg, dj, xebuf, yebuf, dsb, dtb)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                da = dj * WeightG(ig) * WeightG(jg)
                area = area + da
            Next jg
        Next ig

    End Sub

    Private Sub DataSize()
        'ﾃﾞｰﾀｻｲｽﾞの設定

        Nfp = MeshStd * MeshStd
        ReDim Aratio(Nfp), Fpoint(Nfp, 3)
        ReDim XPL(Nfp), YPL(Nfp)
        ReDim Xfp(Nfp), Yfp(Nfp), Zfp(Nfp)

    End Sub

    Private Sub Debug1(ByVal dj As Single, ByVal xeb() As Single, ByVal yeb() As Single)
        '区分面積データを出力して停止
        Dim aa$, fxx$
        Dim i As Integer

        fxx$ = DirOpen$ + "\FEM3Dat6debug1.dat"
        Dim sw As New IO.StreamWriter(fxx$)
        aa$ = "区分面積" + ",  " + Str(dj)
        sw.WriteLine(aa$)
        aa$ = "区分節点（No.、X、Y）"
        sw.WriteLine(aa$)
        For i = 1 To 8
            aa$ = Str$(i)
            aa$ = aa$ + ",  " + Str$(xeb(i))
            aa$ = aa$ + ",  " + Str$(yeb(i))
            sw.WriteLine(aa$)
        Next i
        sw.Close()
        Stop
    End Sub

    Private Sub Debug2()
        '全体座標値を出力して停止
        Dim aa$, fxx$
        Dim i As Integer

        fxx$ = DirOpen$ + "\FEM3Dat6debug2.dat"
        Dim sw As New IO.StreamWriter(fxx$)
        aa$ = "全体座標値（No.、X、Y、Z）"
        sw.WriteLine(aa$)
        For i = 1 To Nfp
            aa$ = Str$(i)
            aa$ = aa$ + ",  " + Str$(Xfp(i))
            aa$ = aa$ + ",  " + Str$(Yfp(i))
            aa$ = aa$ + ",  " + Str$(Zfp(i))
            sw.WriteLine(aa$)
        Next i
        sw.Close()
        Stop
    End Sub

    Private Sub FADatSet2()
        '座標位置荷重ﾃﾞｰﾀの追加
        Dim i, id, nfb As Integer

        nfb = NforceA
        Dim xbuf(nfb), ybuf(nfb), zbuf(nfb) As Single
        Dim fbuf(nfb, Ndim) As Single
        For i = 1 To NforceA
            xbuf(i) = XFA(i)
            ybuf(i) = YFA(i)
            zbuf(i) = ZFA(i)
            For id = 1 To Ndim
                fbuf(i, id) = ForceA(i, id)
            Next id
        Next i

        NforceA = NforceA + Nfp
        ReDim XFA(NforceA), YFA(NforceA), ZFA(NforceA), ForceA(NforceA, Ndim)
        For i = 1 To nfb
            XFA(i) = xbuf(i)
            YFA(i) = ybuf(i)
            ZFA(i) = zbuf(i)
            For id = 1 To Ndim
                ForceA(i, id) = fbuf(i, id)
            Next id
        Next i
        For i = 1 To Nfp
            nfb = nfb + 1
            XFA(nfb) = Xfp(i)
            YFA(nfb) = Yfp(i)
            ZFA(nfb) = Zfp(i)
            For id = 1 To Ndim
                ForceA(nfb, id) = Fpoint(i, id)
            Next id
        Next i

    End Sub

    Private Sub ForceCalc()
        '荷重の計算
        Dim i, j As Integer

        For i = 1 To Nfp
            For j = 1 To 3
                Fpoint(i, j) = Fsum(j) * Aratio(i)
            Next j
        Next i

    End Sub

    Private Sub JacobElem2DL(ByVal kg As Integer, ByRef dj As Single,
    ByVal xeb() As Single, ByVal yeb() As Single,
    ByVal dsb() As Single, ByVal dtb() As Single)
        '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
        'kg･･･ｶﾞｳｽ点番号
        'dj･･･ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの行列式値
        'xeb(),yeb()･･･要素の8節点座標
        'dsb(),dtb()･･･形状関数のS,t偏微分
        Dim c1$, c2$
        Dim ii As Integer
        Dim b1, b2, b3, b4 As Single
        b1 = 0 : b2 = 0 : b3 = 0 : b4 = 0
        For ii = 1 To 8
            b1 = b1 + dsb(ii) * xeb(ii)
            b2 = b2 + dsb(ii) * yeb(ii)
            b3 = b3 + dtb(ii) * xeb(ii)
            b4 = b4 + dtb(ii) * yeb(ii)
        Next ii
        dj = b1 * b4 - b2 * b3
        If dj <= 0 Then
            Call Debug1(dj, xeb, yeb)
            c1$ = "計算実行エラー"
            c2$ = "分割区分の（ガウス点" + LTrim$(Str$(kg))
            c2$ = c2$ + "）でヤコビアン面積が負か０になりました。"
            MsgBox(c2$, 0, c1$)
            End
        End If
    End Sub

    Private Sub MeshCalcL()
        '四辺ﾒｯｼｭのﾒｯｼｭ点算出
        Dim i, ib, ip, j, k, nb As Integer
        Dim area, areaStd, asum, b1, delta As Single
        Dim s, s0, s1, s2, t, t0, t1, t2, xb, xc, yc, yb As Single
        Dim xebuf(8), yebuf(8) As Single

        Ngaus = 3
        PosGaus(3) = 0.77459667 : PosGaus(1) = -PosGaus(3) : PosGaus(2) = 0
        WeightG(1) = 0.55555556 : WeightG(3) = WeightG(1) : WeightG(2) = 0.88888889

        b1 = 0.7071 * Rlen
        XE(1) = Rlen : YE(1) = 0
        XE(2) = b1 : YE(2) = b1
        XE(3) = 0 : YE(3) = Rlen
        XE(4) = -b1 : YE(4) = b1
        XE(5) = -Rlen : YE(5) = 0
        XE(6) = -b1 : YE(6) = -b1
        XE(7) = 0 : YE(7) = -Rlen
        XE(8) = b1 : YE(8) = -b1
        areaStd = Pai * Rlen * Rlen

        asum = 0
        nb = 0
        delta = 2.0 / MeshStd
        For i = 1 To MeshStd
            s0 = -1 + (i - 1) * delta
            s1 = s0 + 0.5 * delta
            s2 = -1 + i * delta
            For j = 1 To MeshStd
                t0 = -1 + (j - 1) * delta
                t1 = t0 + 0.5 * delta
                t2 = -1 + j * delta
                For k = 1 To 8
                    Select Case k
                        Case 1
                            s = s0 : t = t0
                        Case 2
                            s = s1 : t = t0
                        Case 3
                            s = s2 : t = t0
                        Case 4
                            s = s2 : t = t1
                        Case 5
                            s = s2 : t = t2
                        Case 6
                            s = s1 : t = t2
                        Case 7
                            s = s0 : t = t2
                        Case 8
                            s = s0 : t = t1
                    End Select
                    Call ShapeFunc2D(s, t)            '形状関数の計算
                    xb = 0 : yb = 0
                    For ip = 1 To 8
                        xb = xb + XE(ip) * Shape(ip)
                        yb = yb + YE(ip) * Shape(ip)
                    Next ip
                    xebuf(k) = xb
                    yebuf(k) = yb
                Next k
                xc = 0 : yc = 0
                For k = 1 To 8
                    ib = k Mod 2
                    If ib = 0 Then
                        b1 = -0.25
                    Else
                        b1 = 0.5
                    End If
                    xc = xc + b1 * xebuf(k)
                    yc = yc + b1 * yebuf(k)
                Next k
                nb = nb + 1
                XPL(nb) = xc
                YPL(nb) = yc
                Call AreaCalcPL(area, xebuf, yebuf)
                Aratio(nb) = area
                asum = asum + area
            Next j
        Next i

        b1 = 0
        For i = 1 To Nfp
            Aratio(i) = Aratio(i) / asum
            b1 = b1 + aratio(i)
        Next i

    End Sub

    Private Sub MeshGene()
        'メッシュ生成
        Dim kh As Integer

        Call XYPlane(kh)    'XY平面に変換
        If kh < 0 Then
            Me.Close()
        End If

        Call DataSize()     'ﾃﾞｰﾀｻｲｽﾞの設定

        Call MeshCalcL()    '四辺ﾒｯｼｭのﾒｯｼｭ点算出

        Call PosTrans()     '座標変換
        'Call Debug2()

        Call ForceCalc()    '荷重の計算

    End Sub

    Private Sub PlaneCheck(ByRef kh As Integer)
        '外郭面のチェック
        Dim aa$
        Dim i, ke As Integer
        Dim s, t, u, xb, yb, zb As Single
        ReDim KdrawElem(Nelem)

        kh = 0
        For i = 1 To Nelem
            KdrawElem(i) = 1
        Next i
        Call AxisCheck(1, Nelem, Rlenmax, AxisMax, AxisMin, Xdata, Ydata, Zdata)
        'X、Y、Z軸の最小・最大値のﾁｪｯｸ
        EpsL = Rlenmax * 0.00001

        CInc = 3
        CRed = 0.2
        For i = 1 To Nfp
            xb = Xfp(i)
            yb = Yfp(i)
            zb = Zfp(i)
            Call ElemFA(ke, s, t, u, xb, yb, zb) '該当要素の検出
            If ke = 0 Then
                aa$ = "座標位置荷重の座標が構造外にあります！"
                MsgBox(aa$, 0, "データエラー")
                kh = -1
                Exit Sub
            End If
        Next i

    End Sub

    Private Sub PosTrans()
        '座標変換
        Dim i As Integer
        Dim xb, yb, zb As Single
        For i = 1 To Nfp
            xb = XPL(i) * Cx(1) + YPL(i) * Cy(1)
            yb = XPL(i) * Cx(2) + YPL(i) * Cy(2)
            zb = XPL(i) * Cx(3) + YPL(i) * Cy(3)
            Xfp(i) = xb + Xset(3)
            Yfp(i) = yb + Yset(3)
            Zfp(i) = zb + Zset(3)
        Next i

    End Sub

    Sub ShapeFunc2D(ByVal s As Single, ByVal t As Single)
        '形状関数の計算
        's･･･要素のξ座標
        't･･･要素のη座標
        Dim b1, b2, b3, s2, ss, st, t2, tt As Single
        s2 = s * 2 : t2 = t * 2
        ss = s * s : tt = t * t : st = s * t
        b1 = ss * t : b2 = s * tt : b3 = st * 2
        Shape(1) = (-1 + st + ss + tt - b1 - b2) / 4
        Shape(2) = (1 - t - ss + b1) / 2
        Shape(3) = (-1 - st + ss + tt - b1 + b2) / 4
        Shape(4) = (1 + s - tt - b2) / 2
        Shape(5) = (-1 + st + ss + tt + b1 + b2) / 4
        Shape(6) = (1 + t - ss - b1) / 2
        Shape(7) = (-1 - st + ss + tt + b1 - b2) / 4
        Shape(8) = (1 - s - tt + b2) / 2
        Ds(1) = (t + s2 - b3 - tt) / 4
        Ds(2) = -s + st
        Ds(3) = (-t + s2 - b3 + tt) / 4
        Ds(4) = (1 - tt) / 2
        Ds(5) = (t + s2 + b3 + tt) / 4
        Ds(6) = -s - st
        Ds(7) = (-t + s2 + b3 - tt) / 4
        Ds(8) = (-1 + tt) / 2
        Dt(1) = (s + t2 - ss - b3) / 4
        Dt(2) = (-1 + ss) / 2
        Dt(3) = (-s + t2 - ss + b3) / 4
        Dt(4) = -t - st
        Dt(5) = (s + t2 + ss + b3) / 4
        Dt(6) = (1 - ss) / 2
        Dt(7) = (-s + t2 + ss - b3) / 4
        Dt(8) = -t + st
    End Sub

    Sub ShapeFunc2DL(ByVal s As Single, ByVal t As Single,
    ByRef shb() As Single, ByRef dsb() As Single, ByRef dtb() As Single)
        '2D形状関数の計算
        's･･･要素のξ座標
        't･･･要素のη座標
        'shb()･･･形状関数
        'dsb()･･･形状関数のs偏微分
        'dtb()･･･形状関数のt偏微分
        Dim b1, b2, b3, s2, ss, st, t2, tt As Single
        s2 = s * 2 : t2 = t * 2
        ss = s * s : tt = t * t : st = s * t
        b1 = ss * t : b2 = s * tt : b3 = st * 2
        shb(1) = (-1 + st + ss + tt - b1 - b2) / 4
        shb(2) = (1 - t - ss + b1) / 2
        shb(3) = (-1 - st + ss + tt - b1 + b2) / 4
        shb(4) = (1 + s - tt - b2) / 2
        shb(5) = (-1 + st + ss + tt + b1 + b2) / 4
        shb(6) = (1 + t - ss - b1) / 2
        shb(7) = (-1 - st + ss + tt + b1 - b2) / 4
        shb(8) = (1 - s - tt + b2) / 2
        dsb(1) = (t + s2 - b3 - tt) / 4
        dsb(2) = -s + st
        dsb(3) = (-t + s2 - b3 + tt) / 4
        dsb(4) = (1 - tt) / 2
        dsb(5) = (t + s2 + b3 + tt) / 4
        dsb(6) = -s - st
        dsb(7) = (-t + s2 + b3 - tt) / 4
        dsb(8) = (-1 + tt) / 2
        dtb(1) = (s + t2 - ss - b3) / 4
        dtb(2) = (-1 + ss) / 2
        dtb(3) = (-s + t2 - ss + b3) / 4
        dtb(4) = -t - st
        dtb(5) = (s + t2 + ss + b3) / 4
        dtb(6) = (1 - ss) / 2
        dtb(7) = (-s + t2 + ss - b3) / 4
        dtb(8) = -t + st
    End Sub

    Private Sub SpecSet(ByRef kh As Integer)
        '仕様セット
        'kh･･･エラー有無（0:なし、1:有り）
        Dim aa$

        Xset(1) = Val(TextBox1.Text)
        Yset(1) = Val(TextBox2.Text)
        Zset(1) = Val(TextBox3.Text)
        Xset(2) = Val(TextBox4.Text)
        Yset(2) = Val(TextBox5.Text)
        Zset(2) = Val(TextBox6.Text)
        Xset(3) = Val(TextBox7.Text)
        Yset(3) = Val(TextBox8.Text)
        Zset(3) = Val(TextBox9.Text)

        MeshStd = Val(TextBox15.Text)

        Fsum(1) = Val(TextBox12.Text)
        Fsum(2) = Val(TextBox13.Text)
        Fsum(3) = Val(TextBox14.Text)

        'ﾃﾞｰﾀﾁｪｯｸ
        kh = 0
        If MeshStd <= 0 Then
            aa$ = "分割数が間違っています！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            Exit Sub
        End If

    End Sub

    Private Sub XYPlane(ByRef kh As Integer)
        'XY平面に変換
        'kh･･･エラー有無（0:なし、-1：有り）
        Dim aa$
        Dim b1, b2, b3, xl, yl As Single
        b1 = Xset(1) - Xset(3)
        b2 = Yset(1) - Yset(3)
        b3 = Zset(1) - Zset(3)
        xl = Math.Sqrt(b1 * b1 + b2 * b2 + b3 * b3)
        Cx(1) = b1 / xl
        Cx(2) = b2 / xl
        Cx(3) = b3 / xl
        b1 = Xset(2) - Xset(3)
        b2 = Yset(2) - Yset(3)
        b3 = Zset(2) - Zset(3)
        yl = Math.Sqrt(b1 * b1 + b2 * b2 + b3 * b3)
        Cy(1) = b1 / yl
        Cy(2) = b2 / yl
        Cy(3) = b3 / yl

        kh = 0
        b1 = Math.Abs(xl - yl) / xl
        If b1 > 0.0001 Then
            aa$ = "点座標が正しく設定されていません！"
            MsgBox(aa$, 0, "設定エラー")
            kh = -1
        Else
            Rlen = xl
        End If

    End Sub

    Private Sub FEM3Dat6_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim i As Integer

        Fx$ = DirOpen$ + "\FEM3Dat6.tmp"
        Try
            Dim sr As New IO.StreamReader(Fx$)
            For i = 1 To 3
                Xset(i) = sr.ReadLine
                Yset(i) = sr.ReadLine
                Zset(i) = sr.ReadLine
            Next i
            MeshStd = sr.ReadLine
            For i = 1 To 3
                Fsum(i) = sr.ReadLine
            Next i
            sr.Close()
        Catch
            '処理不要
        End Try

        If MeshStd = 0 Then
            MeshStd = 5
        End If
        TextBox1.Text = Str(Xset(1))
        TextBox2.Text = Str(Yset(1))
        TextBox3.Text = Str(Zset(1))
        TextBox4.Text = Str(Xset(2))
        TextBox5.Text = Str(Yset(2))
        TextBox6.Text = Str(Zset(2))
        TextBox7.Text = Str(Xset(3))
        TextBox8.Text = Str(Yset(3))
        TextBox9.Text = Str(Zset(3))
        TextBox15.Text = Str(MeshStd)
        TextBox12.Text = Str(Fsum(1))
        TextBox13.Text = Str(Fsum(2))
        TextBox14.Text = Str(Fsum(3))

    End Sub

    Private Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Dim aa$
        Dim i, ix, kh As Integer

        Call SpecSet(kh)  '仕様セット
        If kh < 0 Then
            Exit Sub
        End If

        Dim sw As New IO.StreamWriter(Fx$)
        For i = 1 To 3
            sw.WriteLine(Xset(i))
            sw.WriteLine(Yset(i))
            sw.WriteLine(Zset(i))
        Next i
        sw.WriteLine(MeshStd)
        For i = 1 To 3
            sw.WriteLine(Fsum(i))
        Next i
        sw.Close()

        Call MeshGene()     'メッシュ生成

        Call PlaneCheck(kh)   '外郭面のチェック
        If kh < 0 Then
            aa$ = "外郭面にない座標値点が設定されました！"
            MsgBox(aa$, "座標エラー")
            Exit Sub
        End If

        aa$ = "新しい座標値荷重を入力データに追加しますか？"
        ix = MsgBox(aa$, 4, "計算終了確認")
        If ix = 6 Then
            Call FADatSet2()    '座標位置荷重ﾃﾞｰﾀの追加
            aa$ = "新しい座標値荷重を入力データに追加しました。"
            aa$ = aa$ + Cr$ + "入力データファイルへの保存が必要です!"
            MsgBox(aa$, 0, "矩形分布荷重の換算処理終了")
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(sender As Object, e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub
End Class